-- Discordian Calendar Calculator
-- by zorg
-- @2014

local sdn = {}
sdn[1* 5] = "Mungday"
sdn[1*50] = "Chaoflux"
sdn[2* 5] = "Mojoday"
sdn[2*50] = "Discoflux"
sdn[3* 5] = "Syaday"
sdn[3*50] = "Confuflux"
sdn[4* 5] = "Zaraday"
sdn[4*50] = "Bureflux"
sdn[5* 5] = "Maladay"
sdn[5*50] = "Afflux"

local sn = {"Chaos","Discord","Confusion","Bureucracy","Aftermath"}
local dn = {"Sweetmorn","Boomtime","Pungenday","Prickle-Prickle","Setting Orange"}
local pr = {"Hail Eris!","Fnord!","If this is confusing you, please consult your pancreas."}

ddate = function()
	local t = os.date("*t", os.time())
	local y = t.year + 1166
	local s,d,w,wd,ord
	
	-- bore year
	s = math.floor(t.yday / 73) + 1 -- chaos, discord, confusion, bureucracy, aftermath
	d = math.floor(t.yday % 73) + 1
	w = math.floor(t.yday /  5) + 1
	wd = math.floor(t.yday % 5) + 1 -- sweetmorn, boomtime, pungenday, prickle-prickle, setting orange
	
	ord = (tostring(w):sub(-1,-1) == '1') and 'st' or ((tostring(w):sub(-1,-1) == '2') and 'nd' or ((tostring(w):sub(-1,-1) == '3') and 'rd' or 'th'))
	
	-- Generic Holidays
	if d == 5 or d == 50 then
		return "Today is " .. sdn[s*d] .. ";" .. sn[s] .. " " .. d .. ", " .. y .. " YOLD." .. " " .. pr[love.math.random(1,#pr)]
	end

	-- leap year; st. tib's day inserted between chs 59 and chs 60 (feb. 29)
	if t.month == 2 and t.day == 29 then 
		return "Today is St. Tib's Day, " .. y .. " YOLD." .. " " .. pr[love.math.random(1,#pr)]
	end

	-- ?????????
	if t.month == 2 and t.day == 30 then
		return "Today is The Unknown Holyday!" .. y .. " YOLD."
	end

	-- elseways
	return "Today is " .. dn[wd] .. " of the " .. w .. ord .. " week;" .. sn[s] .. " " .. d .. ", " .. y .. " YOLD." .. " " .. pr[love.math.random(1,#pr)]
end

return ddate